/**
 */
package highLevelNaoApp.impl;

import highLevelNaoApp.ActivityGroup;
import highLevelNaoApp.Arm;
import highLevelNaoApp.ArmMotion;
import highLevelNaoApp.ArmMotionType;
import highLevelNaoApp.BodyMotion;
import highLevelNaoApp.BodyMotionDirection;
import highLevelNaoApp.BodyPart;
import highLevelNaoApp.BodyStance;
import highLevelNaoApp.Color;
import highLevelNaoApp.Counter;
import highLevelNaoApp.DetectHuman;
import highLevelNaoApp.DetectMotion;
import highLevelNaoApp.DetectSound;
import highLevelNaoApp.DetectTouch;
import highLevelNaoApp.Dice;
import highLevelNaoApp.Finish;
import highLevelNaoApp.Fork;
import highLevelNaoApp.FreeSpeechRecognition;
import highLevelNaoApp.GroupFinish;
import highLevelNaoApp.GroupStart;
import highLevelNaoApp.HLActivity;
import highLevelNaoApp.HeadDirection;
import highLevelNaoApp.HeadMotion;
import highLevelNaoApp.HighLevelNaoAppFactory;
import highLevelNaoApp.HighLevelNaoAppPackage;
import highLevelNaoApp.Join;
import highLevelNaoApp.Language;
import highLevelNaoApp.LearnMotion;
import highLevelNaoApp.Led_Group;
import highLevelNaoApp.Lexicon;
import highLevelNaoApp.Listen;
import highLevelNaoApp.NaoApp;
import highLevelNaoApp.OnDetectTransition;
import highLevelNaoApp.OnListenTransition;
import highLevelNaoApp.OnNotDetectTransition;
import highLevelNaoApp.OnPreemptTransition;
import highLevelNaoApp.PreemptionType;
import highLevelNaoApp.RecordSound;
import highLevelNaoApp.ReplayMotion;
import highLevelNaoApp.ReplaySound;
import highLevelNaoApp.ReportWeather;
import highLevelNaoApp.Sentence;
import highLevelNaoApp.Sleep;
import highLevelNaoApp.Stance;
import highLevelNaoApp.Start;
import highLevelNaoApp.Talk;
import highLevelNaoApp.Transition;
import highLevelNaoApp.TurnLedOff;
import highLevelNaoApp.TurnLedOn;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class HighLevelNaoAppPackageImpl extends EPackageImpl implements HighLevelNaoAppPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass headMotionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bodyMotionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass armMotionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass detectHumanEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass detectSoundEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass listenEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass detectTouchEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass talkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass detectMotionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass bodyStanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass naoAppEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hlActivityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass transitionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass lexiconEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sentenceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass learnMotionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass replayMotionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass diceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass freeSpeechRecognitionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass reportWeatherEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass startEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass finishEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass counterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass activityGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass forkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass joinEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sleepEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass groupStartEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass groupFinishEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass recordSoundEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass replaySoundEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass turnLedOnEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass turnLedOffEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass onDetectTransitionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass onNotDetectTransitionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass onPreemptTransitionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass onListenTransitionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum headDirectionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum bodyMotionDirectionEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum armMotionTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum languageEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum stanceEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum armEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum bodyPartEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum led_GroupEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum colorEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum preemptionTypeEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see highLevelNaoApp.HighLevelNaoAppPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private HighLevelNaoAppPackageImpl() {
		super(eNS_URI, HighLevelNaoAppFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link HighLevelNaoAppPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static HighLevelNaoAppPackage init() {
		if (isInited) return (HighLevelNaoAppPackage)EPackage.Registry.INSTANCE.getEPackage(HighLevelNaoAppPackage.eNS_URI);

		// Obtain or create and register package
		HighLevelNaoAppPackageImpl theHighLevelNaoAppPackage = (HighLevelNaoAppPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof HighLevelNaoAppPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new HighLevelNaoAppPackageImpl());

		isInited = true;

		// Create package meta-data objects
		theHighLevelNaoAppPackage.createPackageContents();

		// Initialize created meta-data
		theHighLevelNaoAppPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theHighLevelNaoAppPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(HighLevelNaoAppPackage.eNS_URI, theHighLevelNaoAppPackage);
		return theHighLevelNaoAppPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHeadMotion() {
		return headMotionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHeadMotion_Direction() {
		return (EAttribute)headMotionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBodyMotion() {
		return bodyMotionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBodyMotion_Direction() {
		return (EAttribute)bodyMotionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBodyMotion_Distance() {
		return (EAttribute)bodyMotionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBodyMotion_Duration() {
		return (EAttribute)bodyMotionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBodyMotion_Speed() {
		return (EAttribute)bodyMotionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBodyMotion_SafetyDistance() {
		return (EAttribute)bodyMotionEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getArmMotion() {
		return armMotionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getArmMotion_ArmMotion() {
		return (EAttribute)armMotionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getArmMotion_Arm() {
		return (EAttribute)armMotionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDetectHuman() {
		return detectHumanEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectHuman_Duration() {
		return (EAttribute)detectHumanEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectHuman_BDetectForever() {
		return (EAttribute)detectHumanEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDetectSound() {
		return detectSoundEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectSound_Duration() {
		return (EAttribute)detectSoundEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectSound_BDetectForever() {
		return (EAttribute)detectSoundEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getListen() {
		return listenEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getListen_Duration() {
		return (EAttribute)listenEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getListen_HasLexicon() {
		return (EReference)listenEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getListen_BSayOptions() {
		return (EAttribute)listenEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getListen_BDetectForever() {
		return (EAttribute)listenEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDetectTouch() {
		return detectTouchEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectTouch_Duration() {
		return (EAttribute)detectTouchEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectTouch_Part() {
		return (EAttribute)detectTouchEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectTouch_BDetectForever() {
		return (EAttribute)detectTouchEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTalk() {
		return talkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTalk_Text() {
		return (EAttribute)talkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTalk_Language() {
		return (EAttribute)talkEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTalk_BHasRuntimeTextSource() {
		return (EAttribute)talkEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTalk_Volume() {
		return (EAttribute)talkEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDetectMotion() {
		return detectMotionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectMotion_Duration() {
		return (EAttribute)detectMotionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDetectMotion_BDetectForever() {
		return (EAttribute)detectMotionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBodyStance() {
		return bodyStanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBodyStance_Stance() {
		return (EAttribute)bodyStanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNaoApp() {
		return naoAppEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNaoApp_Name() {
		return (EAttribute)naoAppEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNaoApp_HasActivity() {
		return (EReference)naoAppEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHLActivity() {
		return hlActivityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHLActivity_Order() {
		return (EAttribute)hlActivityEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHLActivity_HasTransition() {
		return (EReference)hlActivityEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTransition() {
		return transitionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTransition_Name() {
		return (EAttribute)transitionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTransition_HasNextHLActivity() {
		return (EReference)transitionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLexicon() {
		return lexiconEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLexicon_Language() {
		return (EAttribute)lexiconEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLexicon_Sentence() {
		return (EReference)lexiconEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSentence() {
		return sentenceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSentence_Text() {
		return (EAttribute)sentenceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSentence_HasTransition() {
		return (EReference)sentenceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLearnMotion() {
		return learnMotionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLearnMotion_Name() {
		return (EAttribute)learnMotionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLearnMotion_BListenForMotionName() {
		return (EAttribute)learnMotionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getReplayMotion() {
		return replayMotionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getReplayMotion_Name() {
		return (EAttribute)replayMotionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getReplayMotion_BListenForMotionName() {
		return (EAttribute)replayMotionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDice() {
		return diceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFreeSpeechRecognition() {
		return freeSpeechRecognitionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getReportWeather() {
		return reportWeatherEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getReportWeather_GreekCities() {
		return (EAttribute)reportWeatherEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStart() {
		return startEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFinish() {
		return finishEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCounter() {
		return counterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCounter_BIsComparator() {
		return (EAttribute)counterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCounter_SuccessThreshold() {
		return (EAttribute)counterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCounter_Name() {
		return (EAttribute)counterEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCounter_InitialValue() {
		return (EAttribute)counterEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getActivityGroup() {
		return activityGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getActivityGroup_HasActivity() {
		return (EReference)activityGroupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getActivityGroup_HasGroupStartActivity() {
		return (EReference)activityGroupEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getActivityGroup_HasGroupFinishActivity() {
		return (EReference)activityGroupEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFork() {
		return forkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFork_EndsAtJoin() {
		return (EReference)forkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getFork_HasActivityGroup() {
		return (EReference)forkEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getJoin() {
		return joinEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSleep() {
		return sleepEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSleep_Duration() {
		return (EAttribute)sleepEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGroupStart() {
		return groupStartEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGroupFinish() {
		return groupFinishEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRecordSound() {
		return recordSoundEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordSound_Name() {
		return (EAttribute)recordSoundEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordSound_Duration() {
		return (EAttribute)recordSoundEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordSound_BFinishWithTouch() {
		return (EAttribute)recordSoundEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getReplaySound() {
		return replaySoundEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getReplaySound_Name() {
		return (EAttribute)replaySoundEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getReplaySound_Volume() {
		return (EAttribute)replaySoundEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTurnLedOn() {
		return turnLedOnEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTurnLedOn_Leds() {
		return (EAttribute)turnLedOnEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTurnLedOn_Color() {
		return (EAttribute)turnLedOnEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTurnLedOff() {
		return turnLedOffEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTurnLedOff_Leds() {
		return (EAttribute)turnLedOffEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOnDetectTransition() {
		return onDetectTransitionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOnDetectTransition_TouchDetection() {
		return (EAttribute)onDetectTransitionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOnDetectTransition_BOtherEventDetection() {
		return (EAttribute)onDetectTransitionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOnNotDetectTransition() {
		return onNotDetectTransitionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOnPreemptTransition() {
		return onPreemptTransitionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOnPreemptTransition_Type() {
		return (EAttribute)onPreemptTransitionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOnPreemptTransition_TouchDetection() {
		return (EAttribute)onPreemptTransitionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOnPreemptTransition_BOtherEventDetection() {
		return (EAttribute)onPreemptTransitionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOnPreemptTransition_SentenceDetection() {
		return (EAttribute)onPreemptTransitionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOnListenTransition() {
		return onListenTransitionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getHeadDirection() {
		return headDirectionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getBodyMotionDirection() {
		return bodyMotionDirectionEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getArmMotionType() {
		return armMotionTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getLanguage() {
		return languageEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getStance() {
		return stanceEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getArm() {
		return armEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getBodyPart() {
		return bodyPartEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getLed_Group() {
		return led_GroupEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getColor() {
		return colorEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getPreemptionType() {
		return preemptionTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HighLevelNaoAppFactory getHighLevelNaoAppFactory() {
		return (HighLevelNaoAppFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		headMotionEClass = createEClass(HEAD_MOTION);
		createEAttribute(headMotionEClass, HEAD_MOTION__DIRECTION);

		bodyMotionEClass = createEClass(BODY_MOTION);
		createEAttribute(bodyMotionEClass, BODY_MOTION__DIRECTION);
		createEAttribute(bodyMotionEClass, BODY_MOTION__DISTANCE);
		createEAttribute(bodyMotionEClass, BODY_MOTION__DURATION);
		createEAttribute(bodyMotionEClass, BODY_MOTION__SPEED);
		createEAttribute(bodyMotionEClass, BODY_MOTION__SAFETY_DISTANCE);

		armMotionEClass = createEClass(ARM_MOTION);
		createEAttribute(armMotionEClass, ARM_MOTION__ARM_MOTION);
		createEAttribute(armMotionEClass, ARM_MOTION__ARM);

		detectHumanEClass = createEClass(DETECT_HUMAN);
		createEAttribute(detectHumanEClass, DETECT_HUMAN__DURATION);
		createEAttribute(detectHumanEClass, DETECT_HUMAN__BDETECT_FOREVER);

		detectSoundEClass = createEClass(DETECT_SOUND);
		createEAttribute(detectSoundEClass, DETECT_SOUND__DURATION);
		createEAttribute(detectSoundEClass, DETECT_SOUND__BDETECT_FOREVER);

		listenEClass = createEClass(LISTEN);
		createEAttribute(listenEClass, LISTEN__DURATION);
		createEReference(listenEClass, LISTEN__HAS_LEXICON);
		createEAttribute(listenEClass, LISTEN__BSAY_OPTIONS);
		createEAttribute(listenEClass, LISTEN__BDETECT_FOREVER);

		detectTouchEClass = createEClass(DETECT_TOUCH);
		createEAttribute(detectTouchEClass, DETECT_TOUCH__DURATION);
		createEAttribute(detectTouchEClass, DETECT_TOUCH__PART);
		createEAttribute(detectTouchEClass, DETECT_TOUCH__BDETECT_FOREVER);

		talkEClass = createEClass(TALK);
		createEAttribute(talkEClass, TALK__TEXT);
		createEAttribute(talkEClass, TALK__LANGUAGE);
		createEAttribute(talkEClass, TALK__BHAS_RUNTIME_TEXT_SOURCE);
		createEAttribute(talkEClass, TALK__VOLUME);

		detectMotionEClass = createEClass(DETECT_MOTION);
		createEAttribute(detectMotionEClass, DETECT_MOTION__DURATION);
		createEAttribute(detectMotionEClass, DETECT_MOTION__BDETECT_FOREVER);

		bodyStanceEClass = createEClass(BODY_STANCE);
		createEAttribute(bodyStanceEClass, BODY_STANCE__STANCE);

		naoAppEClass = createEClass(NAO_APP);
		createEAttribute(naoAppEClass, NAO_APP__NAME);
		createEReference(naoAppEClass, NAO_APP__HAS_ACTIVITY);

		hlActivityEClass = createEClass(HL_ACTIVITY);
		createEAttribute(hlActivityEClass, HL_ACTIVITY__ORDER);
		createEReference(hlActivityEClass, HL_ACTIVITY__HAS_TRANSITION);

		transitionEClass = createEClass(TRANSITION);
		createEAttribute(transitionEClass, TRANSITION__NAME);
		createEReference(transitionEClass, TRANSITION__HAS_NEXT_HL_ACTIVITY);

		lexiconEClass = createEClass(LEXICON);
		createEAttribute(lexiconEClass, LEXICON__LANGUAGE);
		createEReference(lexiconEClass, LEXICON__SENTENCE);

		sentenceEClass = createEClass(SENTENCE);
		createEAttribute(sentenceEClass, SENTENCE__TEXT);
		createEReference(sentenceEClass, SENTENCE__HAS_TRANSITION);

		learnMotionEClass = createEClass(LEARN_MOTION);
		createEAttribute(learnMotionEClass, LEARN_MOTION__NAME);
		createEAttribute(learnMotionEClass, LEARN_MOTION__BLISTEN_FOR_MOTION_NAME);

		replayMotionEClass = createEClass(REPLAY_MOTION);
		createEAttribute(replayMotionEClass, REPLAY_MOTION__NAME);
		createEAttribute(replayMotionEClass, REPLAY_MOTION__BLISTEN_FOR_MOTION_NAME);

		diceEClass = createEClass(DICE);

		freeSpeechRecognitionEClass = createEClass(FREE_SPEECH_RECOGNITION);

		reportWeatherEClass = createEClass(REPORT_WEATHER);
		createEAttribute(reportWeatherEClass, REPORT_WEATHER__GREEK_CITIES);

		startEClass = createEClass(START);

		finishEClass = createEClass(FINISH);

		counterEClass = createEClass(COUNTER);
		createEAttribute(counterEClass, COUNTER__BIS_COMPARATOR);
		createEAttribute(counterEClass, COUNTER__SUCCESS_THRESHOLD);
		createEAttribute(counterEClass, COUNTER__NAME);
		createEAttribute(counterEClass, COUNTER__INITIAL_VALUE);

		activityGroupEClass = createEClass(ACTIVITY_GROUP);
		createEReference(activityGroupEClass, ACTIVITY_GROUP__HAS_ACTIVITY);
		createEReference(activityGroupEClass, ACTIVITY_GROUP__HAS_GROUP_START_ACTIVITY);
		createEReference(activityGroupEClass, ACTIVITY_GROUP__HAS_GROUP_FINISH_ACTIVITY);

		forkEClass = createEClass(FORK);
		createEReference(forkEClass, FORK__ENDS_AT_JOIN);
		createEReference(forkEClass, FORK__HAS_ACTIVITY_GROUP);

		joinEClass = createEClass(JOIN);

		sleepEClass = createEClass(SLEEP);
		createEAttribute(sleepEClass, SLEEP__DURATION);

		groupStartEClass = createEClass(GROUP_START);

		groupFinishEClass = createEClass(GROUP_FINISH);

		recordSoundEClass = createEClass(RECORD_SOUND);
		createEAttribute(recordSoundEClass, RECORD_SOUND__NAME);
		createEAttribute(recordSoundEClass, RECORD_SOUND__DURATION);
		createEAttribute(recordSoundEClass, RECORD_SOUND__BFINISH_WITH_TOUCH);

		replaySoundEClass = createEClass(REPLAY_SOUND);
		createEAttribute(replaySoundEClass, REPLAY_SOUND__NAME);
		createEAttribute(replaySoundEClass, REPLAY_SOUND__VOLUME);

		turnLedOnEClass = createEClass(TURN_LED_ON);
		createEAttribute(turnLedOnEClass, TURN_LED_ON__LEDS);
		createEAttribute(turnLedOnEClass, TURN_LED_ON__COLOR);

		turnLedOffEClass = createEClass(TURN_LED_OFF);
		createEAttribute(turnLedOffEClass, TURN_LED_OFF__LEDS);

		onDetectTransitionEClass = createEClass(ON_DETECT_TRANSITION);
		createEAttribute(onDetectTransitionEClass, ON_DETECT_TRANSITION__TOUCH_DETECTION);
		createEAttribute(onDetectTransitionEClass, ON_DETECT_TRANSITION__BOTHER_EVENT_DETECTION);

		onNotDetectTransitionEClass = createEClass(ON_NOT_DETECT_TRANSITION);

		onPreemptTransitionEClass = createEClass(ON_PREEMPT_TRANSITION);
		createEAttribute(onPreemptTransitionEClass, ON_PREEMPT_TRANSITION__TYPE);
		createEAttribute(onPreemptTransitionEClass, ON_PREEMPT_TRANSITION__TOUCH_DETECTION);
		createEAttribute(onPreemptTransitionEClass, ON_PREEMPT_TRANSITION__BOTHER_EVENT_DETECTION);
		createEAttribute(onPreemptTransitionEClass, ON_PREEMPT_TRANSITION__SENTENCE_DETECTION);

		onListenTransitionEClass = createEClass(ON_LISTEN_TRANSITION);

		// Create enums
		headDirectionEEnum = createEEnum(HEAD_DIRECTION);
		bodyMotionDirectionEEnum = createEEnum(BODY_MOTION_DIRECTION);
		armMotionTypeEEnum = createEEnum(ARM_MOTION_TYPE);
		languageEEnum = createEEnum(LANGUAGE);
		stanceEEnum = createEEnum(STANCE);
		armEEnum = createEEnum(ARM);
		bodyPartEEnum = createEEnum(BODY_PART);
		led_GroupEEnum = createEEnum(LED_GROUP);
		colorEEnum = createEEnum(COLOR);
		preemptionTypeEEnum = createEEnum(PREEMPTION_TYPE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		headMotionEClass.getESuperTypes().add(this.getHLActivity());
		bodyMotionEClass.getESuperTypes().add(this.getHLActivity());
		armMotionEClass.getESuperTypes().add(this.getHLActivity());
		detectHumanEClass.getESuperTypes().add(this.getHLActivity());
		detectSoundEClass.getESuperTypes().add(this.getHLActivity());
		listenEClass.getESuperTypes().add(this.getHLActivity());
		detectTouchEClass.getESuperTypes().add(this.getHLActivity());
		talkEClass.getESuperTypes().add(this.getHLActivity());
		detectMotionEClass.getESuperTypes().add(this.getHLActivity());
		bodyStanceEClass.getESuperTypes().add(this.getHLActivity());
		learnMotionEClass.getESuperTypes().add(this.getHLActivity());
		replayMotionEClass.getESuperTypes().add(this.getHLActivity());
		diceEClass.getESuperTypes().add(this.getHLActivity());
		reportWeatherEClass.getESuperTypes().add(this.getHLActivity());
		startEClass.getESuperTypes().add(this.getHLActivity());
		finishEClass.getESuperTypes().add(this.getHLActivity());
		counterEClass.getESuperTypes().add(this.getHLActivity());
		activityGroupEClass.getESuperTypes().add(this.getHLActivity());
		forkEClass.getESuperTypes().add(this.getHLActivity());
		joinEClass.getESuperTypes().add(this.getHLActivity());
		sleepEClass.getESuperTypes().add(this.getHLActivity());
		groupStartEClass.getESuperTypes().add(this.getHLActivity());
		groupFinishEClass.getESuperTypes().add(this.getHLActivity());
		recordSoundEClass.getESuperTypes().add(this.getHLActivity());
		replaySoundEClass.getESuperTypes().add(this.getHLActivity());
		turnLedOnEClass.getESuperTypes().add(this.getHLActivity());
		turnLedOffEClass.getESuperTypes().add(this.getHLActivity());
		onDetectTransitionEClass.getESuperTypes().add(this.getTransition());
		onNotDetectTransitionEClass.getESuperTypes().add(this.getTransition());
		onPreemptTransitionEClass.getESuperTypes().add(this.getTransition());
		onListenTransitionEClass.getESuperTypes().add(this.getTransition());

		// Initialize classes, features, and operations; add parameters
		initEClass(headMotionEClass, HeadMotion.class, "HeadMotion", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHeadMotion_Direction(), this.getHeadDirection(), "direction", null, 1, 1, HeadMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bodyMotionEClass, BodyMotion.class, "BodyMotion", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBodyMotion_Direction(), this.getBodyMotionDirection(), "direction", null, 1, 1, BodyMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getBodyMotion_Distance(), ecorePackage.getEDouble(), "distance", null, 0, 1, BodyMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getBodyMotion_Duration(), ecorePackage.getEDouble(), "duration", null, 0, 1, BodyMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getBodyMotion_Speed(), ecorePackage.getEDouble(), "speed", null, 0, 1, BodyMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getBodyMotion_SafetyDistance(), ecorePackage.getEDouble(), "safetyDistance", null, 0, 1, BodyMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(armMotionEClass, ArmMotion.class, "ArmMotion", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getArmMotion_ArmMotion(), this.getArmMotionType(), "armMotion", "OFFER", 1, 1, ArmMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getArmMotion_Arm(), this.getArm(), "arm", "LEFT", 1, 1, ArmMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(detectHumanEClass, DetectHuman.class, "DetectHuman", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDetectHuman_Duration(), ecorePackage.getEDouble(), "duration", null, 0, 1, DetectHuman.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDetectHuman_BDetectForever(), ecorePackage.getEBoolean(), "bDetectForever", null, 0, 1, DetectHuman.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(detectSoundEClass, DetectSound.class, "DetectSound", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDetectSound_Duration(), ecorePackage.getEDouble(), "duration", null, 0, 1, DetectSound.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDetectSound_BDetectForever(), ecorePackage.getEBoolean(), "bDetectForever", null, 0, 1, DetectSound.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(listenEClass, Listen.class, "Listen", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getListen_Duration(), ecorePackage.getEDouble(), "duration", null, 0, 1, Listen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getListen_HasLexicon(), this.getLexicon(), null, "hasLexicon", null, 1, 1, Listen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getListen_BSayOptions(), ecorePackage.getEBoolean(), "bSayOptions", null, 1, 1, Listen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getListen_BDetectForever(), ecorePackage.getEBoolean(), "bDetectForever", null, 0, 1, Listen.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(detectTouchEClass, DetectTouch.class, "DetectTouch", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDetectTouch_Duration(), ecorePackage.getEDouble(), "duration", null, 0, 1, DetectTouch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDetectTouch_Part(), this.getBodyPart(), "part", null, 1, -1, DetectTouch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDetectTouch_BDetectForever(), ecorePackage.getEBoolean(), "bDetectForever", null, 0, 1, DetectTouch.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(talkEClass, Talk.class, "Talk", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTalk_Text(), ecorePackage.getEString(), "text", null, 1, 1, Talk.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTalk_Language(), this.getLanguage(), "language", null, 0, 1, Talk.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTalk_BHasRuntimeTextSource(), ecorePackage.getEBoolean(), "bHasRuntimeTextSource", null, 0, 1, Talk.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTalk_Volume(), ecorePackage.getEInt(), "volume", null, 0, 1, Talk.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(detectMotionEClass, DetectMotion.class, "DetectMotion", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDetectMotion_Duration(), ecorePackage.getEDouble(), "duration", null, 0, 1, DetectMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDetectMotion_BDetectForever(), ecorePackage.getEBoolean(), "bDetectForever", null, 0, 1, DetectMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(bodyStanceEClass, BodyStance.class, "BodyStance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBodyStance_Stance(), this.getStance(), "stance", "STAND", 1, 1, BodyStance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(naoAppEClass, NaoApp.class, "NaoApp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNaoApp_Name(), ecorePackage.getEString(), "name", null, 0, 1, NaoApp.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNaoApp_HasActivity(), this.getHLActivity(), null, "hasActivity", null, 3, -1, NaoApp.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(hlActivityEClass, HLActivity.class, "HLActivity", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHLActivity_Order(), ecorePackage.getEString(), "order", null, 1, 1, HLActivity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHLActivity_HasTransition(), this.getTransition(), null, "hasTransition", null, 0, -1, HLActivity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(transitionEClass, Transition.class, "Transition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTransition_Name(), ecorePackage.getEString(), "name", null, 0, 1, Transition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTransition_HasNextHLActivity(), this.getHLActivity(), null, "hasNextHLActivity", null, 1, 1, Transition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(lexiconEClass, Lexicon.class, "Lexicon", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLexicon_Language(), this.getLanguage(), "language", null, 0, 1, Lexicon.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLexicon_Sentence(), this.getSentence(), null, "sentence", null, 1, -1, Lexicon.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(sentenceEClass, Sentence.class, "Sentence", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSentence_Text(), ecorePackage.getEString(), "text", null, 1, 1, Sentence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSentence_HasTransition(), this.getTransition(), null, "hasTransition", null, 1, 1, Sentence.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(learnMotionEClass, LearnMotion.class, "LearnMotion", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLearnMotion_Name(), ecorePackage.getEString(), "name", null, 1, 1, LearnMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLearnMotion_BListenForMotionName(), ecorePackage.getEBoolean(), "bListenForMotionName", null, 0, 1, LearnMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(replayMotionEClass, ReplayMotion.class, "ReplayMotion", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getReplayMotion_Name(), ecorePackage.getEString(), "name", null, 1, 1, ReplayMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getReplayMotion_BListenForMotionName(), ecorePackage.getEBoolean(), "bListenForMotionName", null, 0, 1, ReplayMotion.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(diceEClass, Dice.class, "Dice", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(freeSpeechRecognitionEClass, FreeSpeechRecognition.class, "FreeSpeechRecognition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(reportWeatherEClass, ReportWeather.class, "ReportWeather", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getReportWeather_GreekCities(), ecorePackage.getEString(), "greekCities", null, 1, -1, ReportWeather.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(startEClass, Start.class, "Start", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(finishEClass, Finish.class, "Finish", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(counterEClass, Counter.class, "Counter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCounter_BIsComparator(), ecorePackage.getEBoolean(), "bIsComparator", null, 1, 1, Counter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCounter_SuccessThreshold(), ecorePackage.getEInt(), "successThreshold", null, 0, 1, Counter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCounter_Name(), ecorePackage.getEString(), "name", null, 1, 1, Counter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCounter_InitialValue(), ecorePackage.getEInt(), "initialValue", null, 0, 1, Counter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(activityGroupEClass, ActivityGroup.class, "ActivityGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getActivityGroup_HasActivity(), this.getHLActivity(), null, "hasActivity", null, 1, -1, ActivityGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActivityGroup_HasGroupStartActivity(), this.getHLActivity(), null, "hasGroupStartActivity", null, 1, 1, ActivityGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActivityGroup_HasGroupFinishActivity(), this.getHLActivity(), null, "hasGroupFinishActivity", null, 1, 1, ActivityGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(forkEClass, Fork.class, "Fork", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getFork_EndsAtJoin(), this.getJoin(), null, "endsAtJoin", null, 1, 1, Fork.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getFork_HasActivityGroup(), this.getActivityGroup(), null, "hasActivityGroup", null, 2, -1, Fork.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(joinEClass, Join.class, "Join", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(sleepEClass, Sleep.class, "Sleep", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSleep_Duration(), ecorePackage.getEDouble(), "duration", null, 1, 1, Sleep.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(groupStartEClass, GroupStart.class, "GroupStart", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(groupFinishEClass, GroupFinish.class, "GroupFinish", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(recordSoundEClass, RecordSound.class, "RecordSound", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRecordSound_Name(), ecorePackage.getEString(), "name", null, 1, 1, RecordSound.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordSound_Duration(), ecorePackage.getEDouble(), "duration", null, 0, 1, RecordSound.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordSound_BFinishWithTouch(), ecorePackage.getEBoolean(), "bFinishWithTouch", null, 0, 1, RecordSound.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(replaySoundEClass, ReplaySound.class, "ReplaySound", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getReplaySound_Name(), ecorePackage.getEString(), "name", null, 1, 1, ReplaySound.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getReplaySound_Volume(), ecorePackage.getEInt(), "volume", null, 0, 1, ReplaySound.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(turnLedOnEClass, TurnLedOn.class, "TurnLedOn", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTurnLedOn_Leds(), this.getLed_Group(), "leds", null, 1, -1, TurnLedOn.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTurnLedOn_Color(), this.getColor(), "Color", null, 1, 1, TurnLedOn.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(turnLedOffEClass, TurnLedOff.class, "TurnLedOff", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTurnLedOff_Leds(), this.getLed_Group(), "leds", null, 1, -1, TurnLedOff.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(onDetectTransitionEClass, OnDetectTransition.class, "OnDetectTransition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getOnDetectTransition_TouchDetection(), this.getBodyPart(), "touchDetection", null, 0, 1, OnDetectTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getOnDetectTransition_BOtherEventDetection(), ecorePackage.getEBoolean(), "bOtherEventDetection", null, 0, 1, OnDetectTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(onNotDetectTransitionEClass, OnNotDetectTransition.class, "OnNotDetectTransition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(onPreemptTransitionEClass, OnPreemptTransition.class, "OnPreemptTransition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getOnPreemptTransition_Type(), this.getPreemptionType(), "type", null, 1, 1, OnPreemptTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getOnPreemptTransition_TouchDetection(), this.getBodyPart(), "touchDetection", null, 0, 1, OnPreemptTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getOnPreemptTransition_BOtherEventDetection(), ecorePackage.getEBoolean(), "bOtherEventDetection", null, 0, 1, OnPreemptTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getOnPreemptTransition_SentenceDetection(), ecorePackage.getEString(), "sentenceDetection", null, 0, 1, OnPreemptTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(onListenTransitionEClass, OnListenTransition.class, "OnListenTransition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize enums and add enum literals
		initEEnum(headDirectionEEnum, HeadDirection.class, "HeadDirection");
		addEEnumLiteral(headDirectionEEnum, HeadDirection.LEFT);
		addEEnumLiteral(headDirectionEEnum, HeadDirection.RIGHT);
		addEEnumLiteral(headDirectionEEnum, HeadDirection.UP);
		addEEnumLiteral(headDirectionEEnum, HeadDirection.DOWN);
		addEEnumLiteral(headDirectionEEnum, HeadDirection.NEUTRAL);

		initEEnum(bodyMotionDirectionEEnum, BodyMotionDirection.class, "BodyMotionDirection");
		addEEnumLiteral(bodyMotionDirectionEEnum, BodyMotionDirection.FORWARDS);
		addEEnumLiteral(bodyMotionDirectionEEnum, BodyMotionDirection.BACKWARDS);
		addEEnumLiteral(bodyMotionDirectionEEnum, BodyMotionDirection.LEFT);
		addEEnumLiteral(bodyMotionDirectionEEnum, BodyMotionDirection.RIGHT);
		addEEnumLiteral(bodyMotionDirectionEEnum, BodyMotionDirection.TOWARDS_SOUND);
		addEEnumLiteral(bodyMotionDirectionEEnum, BodyMotionDirection.TOWARDS_COLOUR);

		initEEnum(armMotionTypeEEnum, ArmMotionType.class, "ArmMotionType");
		addEEnumLiteral(armMotionTypeEEnum, ArmMotionType.OFFER);
		addEEnumLiteral(armMotionTypeEEnum, ArmMotionType.UP);
		addEEnumLiteral(armMotionTypeEEnum, ArmMotionType.WAVE);
		addEEnumLiteral(armMotionTypeEEnum, ArmMotionType.EXTEND);
		addEEnumLiteral(armMotionTypeEEnum, ArmMotionType.OPEN);
		addEEnumLiteral(armMotionTypeEEnum, ArmMotionType.CLOSE);

		initEEnum(languageEEnum, Language.class, "Language");
		addEEnumLiteral(languageEEnum, Language.ENGLISH);
		addEEnumLiteral(languageEEnum, Language.GERMAN);

		initEEnum(stanceEEnum, Stance.class, "Stance");
		addEEnumLiteral(stanceEEnum, Stance.STAND);
		addEEnumLiteral(stanceEEnum, Stance.SIT);
		addEEnumLiteral(stanceEEnum, Stance.CROUCH);
		addEEnumLiteral(stanceEEnum, Stance.ONBACK);

		initEEnum(armEEnum, Arm.class, "Arm");
		addEEnumLiteral(armEEnum, Arm.LEFT);
		addEEnumLiteral(armEEnum, Arm.RIGHT);
		addEEnumLiteral(armEEnum, Arm.BOTH);

		initEEnum(bodyPartEEnum, BodyPart.class, "BodyPart");
		addEEnumLiteral(bodyPartEEnum, BodyPart.RIGHT_HAND);
		addEEnumLiteral(bodyPartEEnum, BodyPart.LEFT_HAND);
		addEEnumLiteral(bodyPartEEnum, BodyPart.HEAD_BACK);
		addEEnumLiteral(bodyPartEEnum, BodyPart.HEAD_MIDDLE);
		addEEnumLiteral(bodyPartEEnum, BodyPart.HEAD_FRONT);
		addEEnumLiteral(bodyPartEEnum, BodyPart.RIGHT_FOOT);
		addEEnumLiteral(bodyPartEEnum, BodyPart.LEFT_FOOT);
		addEEnumLiteral(bodyPartEEnum, BodyPart.ANY_PART);
		addEEnumLiteral(bodyPartEEnum, BodyPart.HEAD);
		addEEnumLiteral(bodyPartEEnum, BodyPart.FEET);
		addEEnumLiteral(bodyPartEEnum, BodyPart.HANDS);

		initEEnum(led_GroupEEnum, Led_Group.class, "Led_Group");
		addEEnumLiteral(led_GroupEEnum, Led_Group.FEET_LEDS);
		addEEnumLiteral(led_GroupEEnum, Led_Group.CHEST_LEDS);
		addEEnumLiteral(led_GroupEEnum, Led_Group.FACE_LEDS);
		addEEnumLiteral(led_GroupEEnum, Led_Group.EAR_LEDS);
		addEEnumLiteral(led_GroupEEnum, Led_Group.ALL_LEDS);

		initEEnum(colorEEnum, Color.class, "Color");
		addEEnumLiteral(colorEEnum, Color.WHITE);
		addEEnumLiteral(colorEEnum, Color.RED);
		addEEnumLiteral(colorEEnum, Color.GREEN);
		addEEnumLiteral(colorEEnum, Color.BLUE);
		addEEnumLiteral(colorEEnum, Color.YELLOW);
		addEEnumLiteral(colorEEnum, Color.MAGENTA);
		addEEnumLiteral(colorEEnum, Color.CYAN);

		initEEnum(preemptionTypeEEnum, PreemptionType.class, "PreemptionType");
		addEEnumLiteral(preemptionTypeEEnum, PreemptionType.ON_START);
		addEEnumLiteral(preemptionTypeEEnum, PreemptionType.ON_FINISH);
		addEEnumLiteral(preemptionTypeEEnum, PreemptionType.ON_DETECT);
		addEEnumLiteral(preemptionTypeEEnum, PreemptionType.ON_NOT_DETECT);

		// Create resource
		createResource(eNS_URI);
	}

} //HighLevelNaoAppPackageImpl
